// Big props and thanks for Shine and Metalwario for allowing use of gifting
// code. It is quite a big gift in of itself, haha!

if not WindowsTheComputer then return end
if srb2p then return end

// Define various icons.
freeslot("SPR_DFRG", "SPR_PKGR", "SPR_BKUP", "SPR_INST", "SPR_PKGE", "SPR_PRG1", "SPR_PRG2", "SPR_PRG3", "SPR_PRG4")
local iconlist = {SPR_PKGR, SPR_INST, SPR_PKGE, SPR_PRG1, SPR_PRG2, SPR_PRG3, SPR_PRG4}
local function giftretrieve(p, spr, rndlimit)
	spr = $ or 0
	rndlimit = $ or 0
	if spr == 0 then spr = iconlist[P_RandomRange(1, #iconlist-rndlimit)] end
	local hurray = P_SpawnMobjFromMobj(p.mo, 0, 0, p.mo.height/2, MT_THOK)
	hurray.fuse = TICRATE/2
	hurray.state = S_WIN_GFX
	hurray.sprite = spr
	hurray.destscale = hurray.scale*3
	hurray.scalespeed = (p.mo.scale/6)*(p.mo.scale/FRACUNIT)
end

local function controlpanel()
	S_StartSound(nil, sfx_uihmsn, consoleplayer)
end

// Admins/hosts have the choice whether a player, as Windows, can gift to other characters.
// If maxed out, multiple Windows players can gift. At that point, though, bit cheatsy, don't ya think?
local cangift = CV_RegisterVar({
	name = "wingift",
	defaultvalue = 1,
	flags = CV_NETVAR | CV_SHOWMODIF | CV_CALL,
	PossibleValue = {disabled=0, default=1, all=2},
	func = controlpanel
})

// And the actual function! Windows shares the variable tracking whether the player
// has given out gifts with Adventure Sonic.
local function WinDefragGift(win)
	if win.exiting or win.gavepowerup or not multiplayer return false end
	if win and win.mo and win.valid and win.mo.valid and win.mo.skin == "windows" then
		local giftsuccess = false
		local oobe = false
		if win.powers[pw_super] != 0 then oobe = true end
		for g in players.iterate
			if (g.mo and g.mo.valid and g.mo != win.mo) and (FixedHypot(g.mo.x - win.mo.x, g.mo.y - win.mo.y) <= 500*FRACUNIT) then
				if g.mo.skin == "samus" or g.mo.skin == "basesamus"	then	
					P_SpawnMobj(g.mo.x, g.mo.y, g.mo.z, P_RandomRange(MT_BMPKU, MT_SATK))
					giftretrieve(g, 0, 5)
					CONS_Printf(g, "\x82"+win.name+"\x80 defragmented an item for you!")
					giftsuccess = true
				elseif g.mo.skin == "duke" then
					P_SpawnMobj(g.mo.x, g.mo.y, g.mo.z, P_RandomRange(MT_PISTOL, MT_SHOTGUN))
					giftretrieve(g, 0, 5)
					CONS_Printf(g, "\x82"+win.name+"\x80 applies a random feature pack. Blast away!")
					giftsuccess = true
				elseif g.mo.skin == "skip" then
					local scrapamount = 16
					if oobe then scrapamount = 32 end
					scrapamount = $*P_RandomRange(4, 12)
					for i = 1,scrapamount
						local isa = P_SpawnMobjFromMobj(win.mo,0,0,0,MT_SKIPMETALSCRAP)
						isa.target = g.mo
						isa.threshold = 2
						isa.shadowscale = FRACUNIT/2
						isa.reactiontime = isa.scale
						isa.color = SKINCOLOR_CLOUDY
						isa.cusval = isa.color
						isa.colorized = true
						P_SetObjectMomZ(isa, FRACUNIT*10, true)
						P_InstaThrust(isa, FixedAngle(360*P_RandomFixed()), 15*P_RandomFixed())
					end
					giftretrieve(g, SPR_PRG2)
					giftsuccess = true
					CONS_Printf(g, "\x82"+win.name+"\x80 flushes out the cache, converting it into scrap for you!")
				elseif g.mo.skin == "modernsonic" and g.boostmeter != nil then
					if g.boostmeter < 110 then g.boostmeter = 110 end
					local readyboost = 15
					if oobe then readyboost = 20 end
					for i = 1,readyboost
						local boostenergy = P_SpawnMobjFromMobj(win.mo, 0, 0, 0, MT_BOOSTENERGY)
						boostenergy.target = g.mo
						boostenergy.boostchasetimer = 225
						boostenergy.color = SKINCOLOR_SKY
						boostenergy.momx = ((P_RandomRange(-10, 10)*FRACUNIT)*P_MobjFlip(boostenergy.target))
						boostenergy.momy = ((P_RandomRange(-10, 10)*FRACUNIT)*P_MobjFlip(boostenergy.target))
						boostenergy.momz = ((P_RandomRange(10, 15)*FRACUNIT)*P_MobjFlip(boostenergy.target)+boostenergy.target.momz)
						boostenergy.scale = boostenergy.target.scale*2
						boostenergy.frame = A|FF_TRANS80|FF_FULLBRIGHT
						if not boostenergy.target.player.boostenergy then boostenergy.target.player.boostenergy = {} end
						table.insert(boostenergy.target.player.boostenergy,boostenergy)
					end
					giftretrieve(g)
					giftsuccess = true
					CONS_Printf(g, "\x82"+win.name+"\x80 reinitializes your (Ready)Boost!")
				elseif g.mo.skin == "nasya" or g.mo.skin == "legacyhibiki" then
					local fireflower = 0
					if g.powers[pw_shield] & SH_FIREFLOWER
						fireflower = SH_FIREFLOWER
					end
					local shield = (g.powers[pw_shield] & SH_NOSTACK)
					local shieldtable
					if (shield <= 1) or shield == SH_PINK then
						if g.mo.skin == "nasya" then shieldtable = {SH_WHIRLWIND,SH_ARMAGEDDON,SH_ELEMENTAL,SH_ATTRACT,SH_FLAMEAURA,SH_BUBBLEWRAP,SH_THUNDERCOIN,(SH_FORCE|1)}
						elseif g.mo.skin == "legacyhibiki" then shieldtable = {SH_WHIRLWIND,SH_ELEMENTAL,SH_FLAMEAURA,(SH_FORCE|1)} end
						g.powers[pw_shield] = (shieldtable[P_RandomRange(1,#shieldtable)])|fireflower
						P_SpawnShieldOrb(g)
						CONS_Printf(g, "\x82"+win.name+"\x80 grants a single use of Security Essentials with a shield.")
						giftretrieve(g)
						giftsuccess = true
					end
				elseif (g.mo.skin == "yoshi" or g.mo.skin == "joshi") and g.yosheggs != nil and g.yosheggs < 8 then
					local egg = (8-g.yosheggs)
					for i = 1,egg
						g.yosheggs = $+1
						local eggcelent = P_SpawnMobjFromMobj(g.mo, 0, 0, 0, MT_FOLLOWEGG)
						eggcelent.threshold = g.yosheggs
						eggcelent.tracer = g.mo
						eggcelent.color = P_RandomRange(1,#skincolors-1)
					end
					giftsuccess = true
					CONS_Printf(g, "\x82"+win.name+"\x80 refreshes your egg capacity. Don't ask how, though.")
				elseif g.mo.skin == "mario" or g.mo.skin == "luigi" and MARIOSHIELDS[SH_SUPERBALL] then
					local snes = P_SpawnMobjFromMobj(g.mo, 0, 0, 0, MT_PITY_BOX)
					snes.flags2 = $|MF2_DONTDRAW
					snes.flags = $|MF_NOCLIPTHING
					P_DamageMobj(snes, g.mo, g.mo)
					if snes and snes.valid then
						giftsuccess = true
						giftretrieve(g)
						CONS_Printf(g, "\x82"+win.name+"\x80 sends you an oldie from Super Mario Land.")
					end
				elseif g.mo.skin == "extralife" or g.mo.skin == "elclassic" then
					P_GivePlayerLives(g, 1)
					P_PlayLivesJingle(g)
					giftsuccess = true
					giftretrieve(g, SPR_BKUP)
					CONS_Printf(g, "\x82"+win.name+"\x80 performs a backup of you, granting a restore point!")
				elseif (g.mo.skin == "speccy" or g.mo.skin == "legacyspeccy") and g.speccy and g.speccy.exp and g.speccy.rings then
					g.speccy.exp = $ + (P_RandomRange(32,128)+g.speccy.chaobonus)*g.speccy.multiplier/FRACUNIT
					g.speccy.rings = $ + P_RandomRange(8,16)
					if g.powers[pw_super] then g.speccy.supertime = $ + 32
					elseif emeralds == 127 then g.speccy.supertime = $ + 64 end
					giftsuccess = true
					giftretrieve(g)
					CONS_Printf(g, "EXPerience the best with \x82"+win.name+"\x80.")
				elseif g.mo.skin == "warui" and g.warioland != false then
					local warios = P_RandomRange(16,64)
					for i = 1,warios
						local gem = P_SpawnMobjFromMobj(g.mo, 0, 0, 0, MT_WARIOCOIN)
						gem.flags = $ & ~MF_SPECIAL
						P_SetObjectMomZ(gem, P_RandomRange(16,24)*FRACUNIT)
						P_InstaThrust(gem, FixedAngle(P_RandomRange(0, 359)*FRACUNIT), 1*FRACUNIT)
						gem.scale = $*2
						gem.state = gem.info.spawnstate
						gem.wcoin = true
					end
					giftsuccess = true
					giftretrieve(g)
					CONS_Printf(g, "\x82"+win.name+"\x80 uncovers some treasure for you.")
					if g.fartready < 3 then
						g.fartready = 3
						g.tossdelay = 0
						CONS_Printf(g, "Oh, and refreshes your farts, too.")
					end
				elseif g.mo.skin == "honey" then
					g.honey.resources = 2
					g.haswingmeter = true
					giftsuccess = true
					giftretrieve(g)
					CONS_Printf(g, "\x82"+win.name+"\x80 recovers your meter with a savestate!")
				elseif g.mo.skin == "gms" or g.mo.skin == "supersonic" then
					local shiny = 20
					shiny = $+P_RandomRange(-3, 5)
					if oobe then shiny = $*2 end
					P_GivePlayerRings(g, shiny)
					giftsuccess = true
					giftretrieve(g)
					CONS_Printf(g, "Using a temporary pagefile, \x82"+win.name+"\x80 grants you "+shiny+" rings!")
				elseif g.mo.skin == "robe" and g.robeenergy < 80 then
					g.robeenergy = 80
					g.roberegen = 0
					giftsuccess = true
					giftretrieve(g)
					CONS_Printf(g, "\x82"+win.name+"\x80 energizes you back to full!")
				elseif g.mo.skin == "deton" and not (g.powers[pw_shield] & SH_ARMAGEDDON) then
					P_SwitchShield(g, SH_ARMAGEDDON)
					P_SpawnShieldOrb(g)
					giftsuccess = true
					giftretrieve(g)
					CONS_Printf(g, "\x82"+win.name+"\x80 grants you an \x85 Armageddon Shield\x80... oh dear.")
				elseif g.mo.skin == "kiryu" and g.mo.kiryuinfo.heatdamage < 12000 then
					if g.mo.kiryuinfo.heatactive then
						g.mo.kiryuinfo.heattime = $ + 10*TICRATE
						g.mo.kiryuinfo.heatdamage = $ + 5000
						CONS_Printf(g, "\x82"+win.name+"\x80 extends your Heat Mode. Don't get thermal throttled!")
					elseif not g.mo.kiryuinfo.heatactive then
						g.mo.kiryuinfo.heatdamage = $ + P_RandomRange(3,7)*1000
						if g.mo.kiryuinfo.heatdamage >= 12000 then CONS_Printf(g, "\x82"+win.name+"\x80 tops up your Heat Mode meter.")
						else CONS_Printf(g, "\x82"+win.name+"\x80 fills your Heat Mode meter with hyper-threading.") end
					end
					giftsuccess = true
					giftretrieve(g)
				elseif g.mo.skin == "silver" and g.mo.silv_energy < SILVER_MAX_ENERGY then
					g.mo.silv_energy = SILVER_MAX_ENERGY
					CONS_Printf(g, "\x82"+win.name+"\x80 pagefiles your energy back to full.")
					giftsuccess = true
					giftretrieve(g)
				elseif g.mo.skin == "mizzy" and g.mizzyphase < 5*TICRATE then
					g.mizzyphase = 5*TICRATE
					CONS_Printf(g, "\x82"+win.name+"\x80 accesses your Phase Meter to fill it back up.")
					giftsuccess = true
					giftretrieve(g)
				elseif g.mo.skin == "inachair" and (g.rkaim.cooldown > 0 or (g.dethroned or g.fuck > 0)) and g.playerstate != PST_DEAD then
					// Inazuma is aware of this. Bless their soul.
					g.rkaim.cooldown = 0
					if (g.dethroned or g.fuck > 0) then
						g.fuck = 0
						g.dethroned = false
						P_ResetPlayer(g)
						P_PlayLivesJingle(g)
						g.mo.state = S_PLAY_WALK
						CONS_Printf(g, "You were in range for \x82"+win.name+"\x80 to restore you back onto a wheelchair.")
					else
						CONS_Printf(g, "\x82"+win.name+"\x80 refreshes you back up to speed.")
					end
					giftsuccess = true
					giftretrieve(g)
				elseif g.mo.skin == "bubsy" and g.mo.yourenotsotough != nil then
					P_SwitchShield(g, (SH_FORCE|4))
					CONS_Printf(g, "\x82"+win.name+"\x80 applies a slightly enhanced Force Shield upon you.")
					giftsuccess = true
					giftretrieve(g)
				else // Should a character not have a custom interaction...
					local isshieldgift = P_RandomChance(FRACUNIT/2)
					local shieldtable = {SH_WHIRLWIND,SH_ARMAGEDDON,SH_ELEMENTAL,SH_ATTRACT,SH_FLAMEAURA,SH_BUBBLEWRAP,SH_THUNDERCOIN,(SH_FORCE|1)}
					local curshield = (g.powers[pw_shield])
					if isshieldgift and ((curshield <= 1) or curshield == SH_PINK) then
						P_SwitchShield(g, shieldtable[P_RandomRange(1,#shieldtable)])
						P_SpawnShieldOrb(g)
						giftretrieve(g)
						giftsuccess = true
						S_StartSound(g.mo, sfx_s1af, g)
						CONS_Printf(g, "\x82"+win.name+"\x80 grants you a random shield!")
					else
						local shiny = P_RandomRange(10, 25)
						P_GivePlayerRings(g, shiny)
						giftsuccess = true
						giftretrieve(g)
						S_StartSound(g.mo, sfx_itemup, g)
						CONS_Printf(g, "\x82"+win.name+"\x80 grants you "+shiny+" rings!")
					end
				end
			end
		end
		if giftsuccess then
			for d = 1,8
				local sprk = P_SpawnMobjFromMobj(win.mo,0,0,0, MT_THOK)
				sprk.state = S_IVSP
				sprk.fuse = 70
				P_InstaThrust(sprk, win.mo.angle+(ANGLE_45*d), 18*FRACUNIT)
			end
			S_StartSound(win.mo, sfx_cdfm73)
			if cangift.value == 1 then
				for workgroup in players.iterate
					if workgroup and workgroup.valid and workgroup.mo and workgroup.mo.valid and workgroup.mo.skin == "windows" then
						workgroup.gavepowerup = true
						CONS_Printf(workgroup, "\x82"+win.name+"\x80 has used the gifting function in this map.")
					end
				end
			end
			win.gavepowerup = true
			local ssd = P_SpawnMobjFromMobj(win.mo, 0, 0, win.mo.height/2, MT_THOK)
			ssd.state = S_WIN_GFX
			ssd.sprite = SPR_DFRG
			ssd.fuse = TICRATE/2
			ssd.destscale = win.mo.scale*3
			ssd.scalespeed = (win.mo.scale/6)*(win.mo.scale/FRACUNIT)
		end
	end
	if CV_FindVar("windbg").value then CONS_Printf(win, "Gift check ran!") end
end

addHook("PlayerThink", function(player)
	if not (multiplayer and gametype == GT_COOP) then return end
	if (player.mo and player.mo.valid) and player.mo.skin == "windows" then
		// Prepare for gift...
		if player.cmd.buttons & (BT_CUSTOM3) and player.cmd.buttons & (BT_SPIN) and player.speed == 0
		and P_IsObjectOnGround(player.mo) and player.exiting == 0 and cangift.value > 0 then
			if (player.mo.state == S_PLAY_STND or player.mo.state == S_PLAY_WAIT or player.mo.state == S_PLAY_EDGE)
			and not player.gavepowerup and leveltime >= 3*TICRATE then
				player.ssdtrim = TICRATE/2
				player.powers[pw_nocontrol] = TICRATE/3
				WinDefragGift(player)
			end
		end
	end
end)